"""
    VRt.Studio [ST]

    The version of the OpenAPI document: 6.3.1926
    Contact: servicedesk@veeroute.com
    Auto Generated
"""


import re  # noqa: F401
import sys  # noqa: F401

from vrt_lss_studio.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from vrt_lss_studio.exceptions import ApiAttributeError


def lazy_import():
    from vrt_lss_studio.model.attributes import Attributes
    from vrt_lss_studio.model.cargo_placement import CargoPlacement
    from vrt_lss_studio.model.trip_state_flag import TripStateFlag
    globals()['Attributes'] = Attributes
    globals()['CargoPlacement'] = CargoPlacement
    globals()['TripStateFlag'] = TripStateFlag


class TripState(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('flags',): {
            'max_items': 9,
            'min_items': 0,
        },
        ('order_key',): {
            'max_length': 1024,
            'min_length': 1,
        },
        ('demand_key',): {
            'max_length': 1024,
            'min_length': 1,
        },
        ('event_key',): {
            'max_length': 1024,
            'min_length': 1,
        },
        ('location_key',): {
            'max_length': 1024,
            'min_length': 1,
        },
        ('cargo_placements',): {
            'max_items': 1000,
            'min_items': 0,
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'time': (datetime,),  
            'flags': ([TripStateFlag],),  
            'order_key': (str, none_type,),  
            'demand_key': (str, none_type,),  
            'event_key': (str, none_type,),  
            'location_key': (str, none_type,),  
            'cargo_placements': ([CargoPlacement],),  
            'attributes': (Attributes,),  
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'time': 'time',  
        'flags': 'flags',  
        'order_key': 'order_key',  
        'demand_key': 'demand_key',  
        'event_key': 'event_key',  
        'location_key': 'location_key',  
        'cargo_placements': 'cargo_placements',  
        'attributes': 'attributes',  
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, time, *args, **kwargs):  
        """TripState - a model defined in OpenAPI

        Args:
            time (datetime): Start time according to the [RFC 3339, section 5.6 (ISO 8601)](https://tools.ietf.org/html/rfc3339#section-5.6).

        Keyword Args:
            flags ([TripStateFlag]): List of flags, describing current state.  Possible flag values (locations):   * `AROUND_LOCATION` - a performer is around a location: finished relocation to the location by routing means.   * `INSIDE_LOCATION` - a performer is inside a location considering arrival and departure time.  Possible flag values (time windows):   * `INSIDE_WORKING_WINDOW` - a performer is inside a formal working shift window from the input task.   * `INSIDE_LOCATION_WINDOW` - a performer is inside an availability window of a location.   * `INSIDE_EVENT_HARD_WINDOW` - a performer is inside the hard window of an event.   * `INSIDE_EVENT_SOFT_WINDOW` - a performer is inside the soft window of an event.  Possible flag values (work states):   * `ON_DEMAND` - a performer is working on a demand.   * `WAITING` - a performer is waiting.         * `RELOCATING` - a performer is relocating.   * `BREAK` - the performer is on a break. . defaults to []  
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            order_key (str, none_type): Key of the order with which an action is taken.. [optional] if omitted the server will use the default value of "null"  
            demand_key (str, none_type): Key of the demand with which an action is taken.. [optional] if omitted the server will use the default value of "null"  
            event_key (str, none_type): Key of the event at which an action is taken.. [optional] if omitted the server will use the default value of "null"  
            location_key (str, none_type): Key of the location at which an action is taken.. [optional] if omitted the server will use the default value of "null"  
            cargo_placements ([CargoPlacement]): List of cargo placements.. [optional] if omitted the server will use the default value of []  
            attributes (Attributes): [optional]  
        """

        flags = kwargs.get('flags', [])
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.time = time
        self.flags = flags
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, time, *args, **kwargs):  
        """TripState - a model defined in OpenAPI

        Args:
            time (datetime): Start time according to the [RFC 3339, section 5.6 (ISO 8601)](https://tools.ietf.org/html/rfc3339#section-5.6).

        Keyword Args:
            flags ([TripStateFlag]): List of flags, describing current state.  Possible flag values (locations):   * `AROUND_LOCATION` - a performer is around a location: finished relocation to the location by routing means.   * `INSIDE_LOCATION` - a performer is inside a location considering arrival and departure time.  Possible flag values (time windows):   * `INSIDE_WORKING_WINDOW` - a performer is inside a formal working shift window from the input task.   * `INSIDE_LOCATION_WINDOW` - a performer is inside an availability window of a location.   * `INSIDE_EVENT_HARD_WINDOW` - a performer is inside the hard window of an event.   * `INSIDE_EVENT_SOFT_WINDOW` - a performer is inside the soft window of an event.  Possible flag values (work states):   * `ON_DEMAND` - a performer is working on a demand.   * `WAITING` - a performer is waiting.         * `RELOCATING` - a performer is relocating.   * `BREAK` - the performer is on a break. . defaults to []  
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            order_key (str, none_type): Key of the order with which an action is taken.. [optional] if omitted the server will use the default value of "null"  
            demand_key (str, none_type): Key of the demand with which an action is taken.. [optional] if omitted the server will use the default value of "null"  
            event_key (str, none_type): Key of the event at which an action is taken.. [optional] if omitted the server will use the default value of "null"  
            location_key (str, none_type): Key of the location at which an action is taken.. [optional] if omitted the server will use the default value of "null"  
            cargo_placements ([CargoPlacement]): List of cargo placements.. [optional] if omitted the server will use the default value of []  
            attributes (Attributes): [optional]  
        """

        flags = kwargs.get('flags', [])
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.time = time
        self.flags = flags
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
